""" Script for configuring the build system for SIP-generated Python modules.
"""
import os.path
import sipconfig
import subprocess
from PyQt4 import pyqtconfig
import sys

def _run_cmd(args, suppress_err=False):
    cmdline = " ".join(args)
    sys.stdout.write(cmdline + "\n")
    r = os.system(cmdline)
    if r != 0:
        if not suppress_err:
            sys.stderr.write("Command failed (exit code %d)\n" % (r,))
            # sip should inform the user of the error
        sys.exit(1)
    ''' Why does this not work? (sip bug by the looks of it)
    try: subprocess.check_call(args)
    except subprocess.CalledProcessError, err:
        # sip should inform the user of the error
        sys.exit(1)
    '''

def _sipjoin(*args):
    """ sip expects / path separator regardless of platform. """
    return "/".join(args)

conf = pyqtconfig.Configuration()

sipfile = "tst.sip"
buildfile = "tst.sbf"
_run_cmd([conf.sip_bin, "-e", "-b", buildfile, "-c", ".", "-I", conf.pyqt_sip_dir,
    conf.pyqt_sip_flags, sipfile], suppress_err=True)
if not os.access(buildfile, os.F_OK):
    sipconfig.error("Unable to create the C++ code.")

makefile = pyqtconfig.QtGuiModuleMakefile(conf, buildfile.rsplit("/", 1)[-1])
makefile.extra_libs = ["tst"]
makefile.extra_lib_dirs = ["."]
makefile.generate()
